package F5::ASMConfig::Entity::PolicySignatureSet;

use strict;
use warnings;

use base qw/F5::ASMConfig::Entity::Base F5::ASMConfig::PolicySignatureSet/;

#----------------------------------------------------------------------

sub before_store {
    my($self, %params) = @_;

    my $store_obj = $params{store_obj};
    my $policy = $params{policy} || $self->{policy};
    my $dbh = $params{dbh} || $self->{dbh};

    if (!$policy->{policy_type}) {
        $policy = F5::ASMConfig::Cache::get_cached_policy(policy => { $policy },
                                                          dbh => $dbh,);
    }

    if ($policy->{policy_type} && $policy->{policy_type} == F5::ASMConfig::PolicyType::POLICY_TYPE_PARENT()
        && !$self->get_new_value(%params, field_name => 'flg_learn')) {
        $params{store_obj}->{flg_learn}  = 1;    	    	    	    	    		 
    }
    return {};
}

#----------------------------------------------------------------------

1;
