package F5::ASMConfig::Entity::PolicyThreatCampaign;

use strict;
use warnings;

use F5::ASMConfig::ASMConfig;
use base qw/F5::ASMConfig::Entity::Base F5::ASMConfig::PolicyThreatCampaign/;

#----------------------------------------------------------------------

sub get_staging_period_start_time {
    my($class, %params) = @_;
    my $policy = $params{policy};

    my $staging_period = $params{dbh}->selectrow_array(<<EndQuery, undef, $params{policy}->{policy_id});
SELECT threat_campaign_quarantined_period
  FROM PLC.PL_POLICY_THREAT_CAMPAIGN_ATTRIBUTES
  WHERE policy_id = ?
EndQuery

    my $now = time();
    my $staging_start_time = $now - ($staging_period * 60*60*24);

    return $staging_start_time;
}

#----------------------------------------------------------------------

sub rest_search_filters {
    return [
         F5::ASMConfig::SearchFilter->new(field_name => 'threat_campaign__status',
                                          field_comparison => F5::ASMConfig::FieldComparison::FIELD_COMPARISON_EQ(),
                                          field_value => F5::ASMConfig::ThreatCampaignStatus::THREAT_CAMPAIGN_STATUS_ACTIVE()),
           ];
}

#----------------------------------------------------------------------

1;


