package F5::Ctmm;

use strict;
use warnings;

use Google::ProtocolBuffers::Dynamic;
use File::Slurp;
use File::Find;
use File::Basename;

#----------------------------------------------------------------------

sub init {
    my(%params) = @_;
    my $base_dir = $params{base_dir};

    my $p = Google::ProtocolBuffers::Dynamic->new($base_dir);
    find({
          no_chdir => 1,
          wanted => sub {
              my $filename = basename($File::Find::name);
              if (-f $File::Find::name && $filename =~ /\.proto$/) {
                  $p->load_file($filename);
              }
          },
         },
         $base_dir);

    $p->map({package => 'ctmm', prefix => 'ctmm'});
}

#----------------------------------------------------------------------

1;
