package F5::IpUtils;

use strict;
use warnings;

use Socket qw(:DEFAULT inet_pton inet_ntop);

#----------------------------------------------------------------------
sub split_ip_route{
  my  %params = (@_);
  my  $ip_add = $params{ip_address};
  my  $die_on_error = defined($params{die_on_error}) ? $params{die_on_error} : 1;
  my  $norm_without_route = $ip_add;
  my  $route  = 0;

  if (! defined $ip_add) {
      if ($die_on_error) {
          die "IP Address was not specified\n";
      }
      else {
          return {completed_successfully => 0,
                 };
      }
  }

  if ( $ip_add =~ /^(.*)\%([0-9]+)$/g ){
    $norm_without_route = $1;
    $route  = $2;
  }  
 
  my $is_valid_ip = (defined inet_pton(AF_INET, $norm_without_route) || defined inet_pton(AF_INET6, $norm_without_route)) ? 1 : 0;
 
  if (! $is_valid_ip) {
      if ($die_on_error) {
          die "The ip '$ip_add' is not valid. \n";
      }
      else {
          return {completed_successfully => 0,
                 };
      }
  }

  return { completed_successfully => 1,
           ip_address => $norm_without_route,
           route_domain => $route,
         }
}
#----------------------------------------------------------------------
1;

