package F5::LWP::UserAgent;

use strict;
use warnings;

use LWP::Protocol::http;

use F5::ServerLookup;
use F5::ParseUri;
use F5::Utils::Net;

use base 'LWP::UserAgent';

sub request {
    my ($self, $request, @params) = @_;

    my ($app_id, $domain, $object, $query) = F5::ParseUri::parse_uri($request->uri);

    my $proxy_params = F5::Utils::Net::get_proxy_settings();

    unless ($proxy_params->{proxy_uri}) {
        my $ip_address = F5::ServerLookup::get_ip_address($domain, $self->timeout);
        local @LWP::Protocol::http::EXTRA_SOCK_OPTS;
        @LWP::Protocol::http::EXTRA_SOCK_OPTS = ( PeerAddr => $ip_address,
                                              SSL_verifycn_name => $domain,
                                              SSL_hostname => $domain,
                                              Host => $domain);
    }

    local $ENV{PERL_LWP_SSL_VERIFY_HOSTNAME} = ($proxy_params->{proxy_uri}) ? 0 : 1;
    local $ENV{HTTP_PROXY} = $proxy_params->{proxy_uri};
    local $ENV{HTTP_PROXY_USERNAME} = $proxy_params->{proxy_username};
    local $ENV{HTTP_PROXY_PASSWORD} = $proxy_params->{proxy_password};
    local $ENV{HTTPS_PROXY} = $proxy_params->{proxy_uri};
    local $ENV{HTTPS_PROXY_USERNAME} = $proxy_params->{proxy_username};
    local $ENV{HTTPS_PROXY_PASSWORD} = $proxy_params->{proxy_password};
    $self->env_proxy();

    return $self->SUPER::request($request, @params);
}

1;
